#include <fstream>

#define DIM 1010
#define INF 40040

using namespace std;

int n, m, i1, i2, j1, j2, i, j, ok, dir, iv, jv;

int di[] = {0,0,-1,1,-1,1,-1,1};
int dj[] = {-1,1,0,0,1,1,-1,-1};

int a[DIM][DIM];
int d[DIM][DIM];

int main() {
    ifstream fin("taxa.in");
    ofstream fout("taxa.out");
    fin>>n>>m>>i1>>j1>>i2>>j2;
    for (i=1;i<=n;i++) {
        for (j=1;j<=m;j++) {
            fin>>a[i][j];
            d[i][j] = INF;
        }
    }
    d[i1][j1] = 0;
    do{
        ok = 1;
        for (i=1;i<=n;i++)
            for (j=1;j<=m;j++)
                for (dir=0;dir<=7;dir++) {
                    iv = i+di[dir];
                    jv = j+dj[dir];
                    if (iv>0 && iv<=n && jv > 0 && jv<=m && a[iv][jv]!=a[i][j] && d[i][j] > d[iv][jv] + a[iv][jv]*a[i][j]){
                        d[i][j] = d[iv][jv] + a[iv][jv]*a[i][j];
                        ok = 0;
                    }
                    if (iv>0 && iv<=n && jv > 0 && jv<=m && a[iv][jv]==a[i][j] && d[i][j] > d[iv][jv]){
                        d[i][j] = d[iv][jv];
                        ok = 0;
                    }

                }
    } while (!ok);
    fout<<d[i2][j2]<<"\n";
    return 0;
}
