#include <fstream>

#define DIM 1010
#define INF 40040

using namespace std;

int n, m, i1, i2, j1, j2, i, j, ok, dir, iv, jv, u, u1, p;

int di[] = {0,0,-1,1,-1,1,-1,1};
int dj[] = {-1,1,0,0,1,1,-1,-1};

int a[DIM][DIM];
int d[DIM][DIM];
int v[DIM][DIM];

int c[2][DIM*DIM];
int c1[2][DIM*DIM];

int main() {
    ifstream fin("taxa.in");
    ofstream fout("taxa.out");
    fin>>n>>m>>i1>>j1>>i2>>j2;
    for (i=1;i<=n;i++) {
        for (j=1;j<=m;j++) {
            fin>>a[i][j];
            d[i][j] = INF;
        }
    }
    d[i1][j1] = 0;
    c[0][1] = i1;
    c[1][1] = j1;
//    v[i1][j1] = 0;
    u = 1;
    do{
        ok = 1;
        u1 = 0;
        for (p=1;p<=u;p++) {
            i = c[0][p];
            j = c[1][p];
            for (dir=0;dir<=7;dir++) {
                iv = i+di[dir];
                jv = j+dj[dir];
                if (iv>0 && iv<=n && jv > 0 && jv<=m && a[iv][jv]!=a[i][j] && d[iv][jv] > d[i][j] + a[iv][jv]*a[i][j]){
                    d[iv][jv] = d[i][j] + a[iv][jv]*a[i][j];
                    if (v[iv][jv] == 0) {
                        v[iv][jv] = 1;
                        c1[0][++u1] = iv;
                        c1[1][u1] = jv;
                    }
                    ok = 0;
                }
                if (iv>0 && iv<=n && jv > 0 && jv<=m && a[iv][jv]==a[i][j] && d[iv][jv] > d[i][j]){
                    d[iv][jv] = d[i][j];
                    if (v[iv][jv] == 0) {
                        v[iv][jv] = 1;
                        c1[0][++u1] = iv;
                        c1[1][u1] = jv;
                    }
                    ok = 0;
                }
            }
        }
        for (p=1;p<=u1;p++) {
            c[0][p] = c1[0][p];
            c[1][p] = c1[1][p];
            v[c[0][p]][c[1][p]] = 0;
//            c[0][p] = 0;
//            c[1][p] = 0;
        }
        u = u1;
    } while (!ok);
    fout<<d[i2][j2]<<"\n";
    return 0;
}

