#include<iostream>
#include<fstream>
#include<string.h>

#define fin "zone.in"

using namespace std;

char s[405][405];

int n, m ,k,nr ;
int cs;
int vecini[100005],nrv[100005],number[405][405], sw[405][405];
int dir [4][2] = {{ 1 ,0}, { 0, 1 } ,{ -1 ,0 } ,{ 0, -1 } } ;
int vec[100005],pozx[100005],pozy[100005],coada[100005];

void fill (int x, int y ) {
    int i,dirx,diry;
    sw[x][y]=1;
    for (i=0;i<4;i++) {
        dirx=x+dir[i][0];
        diry=y+dir[i][1];
            if (dirx<=n && dirx>=1 && diry<=m && diry>=1 && sw[dirx][diry]==0 && s[dirx][diry]==s[x][y]) {
                number[dirx][diry]=number[x][y];
                fill(dirx,diry);
            }
    }
}

void numara (int x, int y ) {
    int i, dirx, diry ;
    sw[x][y]=1;
    for (i=0;i<4;i++) {
        dirx= x+dir[i][0];
        diry= y+dir[i][1];
        if (dirx>0 && dirx<=n && diry<=m && diry>0) {
            if (sw[dirx][diry]==0 && number[x][y]==number[dirx][diry]) {
                numara(dirx,diry);
            }
            if (number[x][y]!=number[dirx][diry] && vecini[number[dirx][diry]]!=number[x][y]) {
                vecini[number[dirx][diry]]=number[x][y];
                nrv[number[x][y]]++;
            }
        }
    }
}

void getvecini(int x, int y) {
    int i, dirx, diry ;
    sw[x][y]=1;
    for (i=0;i<4;i++) {
        dirx=x+dir[i][0];
        diry=y+dir[i][1];
        if (dirx>0 && dirx<=n && diry>0 && diry<=m ) {
            if (sw[dirx][diry]==0 && number[x][y]==number[dirx][diry])
                getvecini(dirx,diry);
            if (number[x][y]!=number[dirx][diry] && vecini[number[dirx][diry]]!=number[x][y]) {
                vecini[number[dirx][diry]]=number[x][y];
                vec[++vec[0]]=number[dirx][diry];
            }
        }
    }
}

int getsol (int x ,int y ) {
    int dirx,diry, i ;
    cs++;
    sw[x][y]=1;
    for (i=0;i<4;i++) {
        dirx=x+dir[i][0];
        diry=y+dir[i][1];
        if (dirx>0 && diry>0 && dirx<=n && diry<=m && sw[dirx][diry]==0 && nrv[number[dirx][diry]]>=k ) {
            getsol(dirx,diry);
        }
    }
}

int main() {
    int i,j ;
    ifstream f(fin);
    f>>n>>m>>k;
    for (i=1;i<=n;i++) {
        f>>&s[i][1];
    }

    memset(sw,0,sizeof(sw));

    for ( i=1 ;i<=n;i++)
        for (j=1;j<=m;j++)
            if (sw[i][j]==0) {
                number[i][j]=++nr;
                pozx[nr]=i;
                pozy[nr]=j;
                fill(i,j);
            }

    memset(sw,0,sizeof(sw));

    for(i=1;i<=n;i++)
        for(j=1;j<=m;j++)
            if (sw[i][j]==0) {
                numara(i,j);
            }

    memset(sw,0,sizeof(sw));

    int p=0,u=0;

    for (i=1;i<=nr;i++) {
        if (nrv[i]<k)
            coada[++u]=i;
    }

    memset(sw,0,sizeof(sw));
    memset(vecini,0,sizeof(vecini));

    for (;p<=u;) {
        vec[0]=0;
        getvecini(pozx[coada[p]],pozy[coada[p]]);
        for (i=1;i<=vec[0];i++ ) {
            nrv[vec[i]]--;
            if(nrv[vec[i]]==k-1)
                coada[++u]=vec[i];
        }
        ++p;
    }

    int finalrez =0;
    memset(sw,0,sizeof(sw));

    for (i=1;i<=n;i++)
        for (j=1;j<=m;j++)
            if ( sw[i][j]==0 && nrv[number[i][j]]>=k) {
                cs=0;
                getsol(i,j);
                finalrez=max(finalrez,cs);
            }

    ofstream g("zone.out");
    g<<finalrez;
    cout << finalrez;
    return 0 ;
}
