#include <fstream>
#define DIM 302
#include <set>
using namespace std;

int di[] = {-1,1,0,0};
int dj[] = {0,0,1,-1};

set<int> L[DIM*DIM];
int v[DIM*DIM];
int c[DIM*DIM];
int w[DIM*DIM];
char a[DIM][DIM];
int b[DIM][DIM];

int n,m,i,j,maxim,x,k,cc,d,iv,jv,p,u;

void fill(int i, int j, int k) {
    b[i][j] = k;
    w[k]++;
    int iv,jv;
    for (int d=0;d<=3;d++) {
        iv = i+di[d];
        jv = j+dj[d];
        if (b[iv][jv]==0 && a[iv][jv]!=0 && a[iv][jv] == a[i][j])
            fill(iv,jv,k);
    }
}

void df(int i) {
    x+=w[i];
    v[i] = 1;
    for (set<int>::iterator it = L[i].begin();it!=L[i].end();it++) {
        j = *it;
        if (v[j] == 0) {
            v[j] = 1;
            df(j);
        }
    }
}

int main() {
    ifstream fin("zone.in");
    ofstream fout("zone.out");

    fin>>n>>m>>k;
    for (i=1;i<=n;i++)
        fin>>a[i]+1;
    for (i=1;i<=n;i++)
        for (j=1;j<=m;j++) {
            if (b[i][j] == 0)
                fill(i,j,++cc);
        }
    for (i=1;i<=n;i++)
        for (j=1;j<=m;j++)
            for (d=0;d<=3;d++) {
                iv = i+di[d];
                jv = j+dj[d];
                if (iv>0 && iv<=n && jv>0 && jv<=m&&a[i][j]!=a[iv][jv]){
                    L[b[i][j]].insert(b[iv][jv]);
                    L[b[iv][jv]].insert(b[i][j]);
                }
            }
    for (i=1;i<=cc;i++) {
        if (L[i].size() < k) {
            u++;
            c[u] = i;
            v[i] = 1;
        }
    }

    p=1;
    while (p<=u) {
        i = c[p];
        for (set<int>::iterator it = L[i].begin(); it!=L[i].end();it++) {
            j = *it;
            L[j].erase(i);
            if (L[j].size() < k && v[j] == 0) {
                u++;
                c[u] = j;
                v[j] = 1;
            }
        }
        p++;
    }

    for (i=1;i<=cc;i++)
        if (v[i] == 0) {
            x = 0;
            df(i);
            if (x > maxim) {
                maxim = x;
            }
        }
    fout<<maxim<<"\n";
    return 0;
}
