#include <iostream>
#include <fstream>
#include <queue>
using namespace std;

ifstream fin("taxa.in");
ofstream fout("taxa.out");

#define INF 0x3f3f3f3f
struct nod{int a,b;};
const short dx[] = {0, 1, 0, -1, 1, 1, -1, -1};
const short dy[] = {1, 0, -1, 0, 1, -1, 1, -1};
int N, M;
int d[1010][1010];
int c[1010][1010];
queue< nod > Q;
nod p1, p2, w, t;
inline int prod(int A, int B)
{
	if (A == B) return 0;
	return A * B;
}
int main()
{
	fin >> N >> M >> p1.a >> p1.b >> p2.a>> p2.b;
	for (int i = 1; i <= N; i++)
		for (int j = 1; j <= M; j++)
			fin >> d[i][j], c[i][j] = INF;

	c[p1.a][p1.b] = 0;
	Q.push(p1);
	for (; !Q.empty(); Q.pop())
	{
		w = Q.front();
		for (int k = 0; k < 8; k++)
		{
			t = w;
            t.a += dx[k]; t.b += dy[k];
			if (c[t.a][t.b] > c[w.a][w.b] + prod(d[w.a][w.b], d[t.a][t.b]))
				(c[t.a][t.b] = c[w.a][w.b] + prod(d[w.a][w.b], d[t.a][t.b])), Q.push(t);
		}
	}

	fout << c[p2.a][p2.b] << '\n';
	fout.close();
	return 0;
}

