#include<stdio.h>
#include<vector>
#include<string.h>
#include<iostream>
#include<fstream>

#define fin "zone.in"
#define fout "zone.out"

using namespace std;

int n ,m,k,thissol;
char ch[400][400];
int sw[400][400], val[400][400];
int vecini[100005];
int nrlev[100005];
int coada[100005];
int sz[100005];
vector<int> v[100005];

int comp;

int dir[7][4] = { {1,0} , {0 ,1 } , { -1,0 } , { 0 , -1 } } ;

int fill(int x, int y ) {
    sw[x][y]=1;
    sz[comp]++;
    for (int i = 0 ;i<4 ;i++) {
        if (x+dir[i][0]>0 && x+dir[i][0]<=n && y+dir[i][1] >0 && y+dir[i][1] <=m && ch[x][y]==ch[x+dir[i][0]][y+dir[i][1]] && sw[x+dir[i][0]][y+dir[i][1]]==0) {
            val[x+dir[i][0]][y+dir[i][1]]=val[x][y];
            fill(x+dir[i][0],y+dir[i][1]);
        }
    }
}

void go(int x, int y ) {
    sw[x][y]=1;
    int valc, valnext;
    for (int i =0;i<4;i++)
        if (x+dir[i][0]>0 && x+dir[i][0]<=n && y+dir[i][1]>0 && y+dir[i][1]<=m) {
            valnext=val[x+dir[i][0]][y+dir[i][1]];
            valc=val[x][y];
            if (sw[x+dir[i][0]][y+dir[i][1]]==0 && valnext==valc)
                go(x+dir[i][0],y+dir[i][1]);
            else
                if (valnext!=valc && vecini[valnext]!=valc) {
                    vecini[valnext]=valc;
                    v[valc].push_back(valnext);
                }
        }
}

void numarasol2(int x) {
    thissol+=sz[x];
    vecini[x]=1;
    for (int i= 0; i<v[x].size();i++ )
        if (vecini[v[x][i]]==0 && nrlev[v[x][i]]>=k)
            numarasol2(v[x][i]);
}

int main(){
    int i,j;
    FILE *f =fopen(fin,"r");
    fscanf(f,"%d%d%d", &n , &m , &k );
    for (i=1;i<=n;i++)
        fscanf(f,"%s", &ch[i][1]);

    int nr =0;

    for ( i=1;i<=n;i++)
        for (j=1;j<=m;j++)
            if (sw[i][j]==0) {
                val[i][j]=++nr;
                comp=nr;
                fill(i,j);
            }

    memset(sw,0,sizeof(sw));

    for (i=1;i<=n;i++)
        for (j=1;j<=m;j++)
            if (sw[i][j]==0) {
                go(i,j);
            }

    int u=0,p=0;

    for (i=1;i<=nr;i++) {
        nrlev[i]=v[i].size();
        if (nrlev[i]<k)
            coada[++u]=i;
    }

    while (u>=p){
        int nod = coada[p];
        for (i = 0; i<v[nod].size();i++) {
            nrlev[v[nod][i]]--;
            if(nrlev[v[nod][i]]==k-1)
                coada[++u]=v[nod][i];
        }
        ++p;
    }

    for (i=1;i<=n;i++)
        for(j=1;j<=m;j++)
            if((nrlev[val[i][j]]<k))
                val[i][j]= -1;

    int maxsol = 0;
    memset(sw,0,sizeof(sw));
    memset(vecini,0,sizeof(vecini));

    for (i =1; i<=n;i++)
        for (j=1;j<=m;j++)
            if(val[i][j]<=0)
                sw[i][j]=1;

    ofstream g(fout);

    for (i=1;i<=n;i++)
        for (j=1;j<=m;j++) {
            if (nrlev[val[i][j]]>=k && vecini[val[i][j]]==0) {
                thissol=0;
                numarasol2(val[i][j]);
                maxsol=max(maxsol,thissol);
            }
        }

    cout <<maxsol;
    g << maxsol ;
    return 0 ;
}
